Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/WrapperExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/WrapperExpression.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/WrapperExpression.cs	(revision 14602)
@@ -0,0 +1,14 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+    public abstract class WrapperExpression<T> : StatefullExpression<T>
+    {
+        protected WrapperExpression(T state) : base(state, null)
+        {
+        }
+
+        public override string ToString()
+        {
+            return State.ToString();
+        }
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankDuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankDuplicateExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankDuplicateExpressions.cs	(revision 14602)
@@ -1,127 +1,127 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+    using HeuristicLab.Algorithms.PushGP.Interpreter;
+    using HeuristicLab.Algorithms.PushGP.Stack;
 
-  /// <summary>
-  ///     Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item.
-  ///     The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
-  /// </summary>
-  /// <typeparam name="T">Stacktype</typeparam>
-  public abstract class YankDuplicateExpression<T> : StatelessExpression
-  {
-    public void Eval(IStack<T> stack, IStack<long> integerStack)
+    /// <summary>
+    ///     Pushes a copy of an indexed item "deep" in the stack onto the top of the stack, without removing the deep item.
+    ///     The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
+    /// </summary>
+    /// <typeparam name="T">Stacktype</typeparam>
+    public abstract class YankDuplicateExpression<T> : StatelessExpression
     {
-      T item;
-      if (this.TryGetItem(stack, integerStack, out item)) stack.Push(item);
+        protected YankDuplicateExpression(string stringRepresentation) : base(stringRepresentation)
+        {
+        }
+
+        public void Eval(IStack<T> stack, IStack<long> integerStack)
+        {
+            T item;
+            if (this.TryGetItem(stack, integerStack, out item)) stack.Push(item);
+        }
+
+        public void Eval(IStack<Expression> stack, IStack<long> integerStack)
+        {
+            Expression item;
+            if (this.TryGetItem(stack, integerStack, out item)) stack.Push(item);
+        }
+
+        public void Eval(IStack<long> integerStack)
+        {
+            if ((integerStack.Count < 2) || (integerStack.Top > integerStack.Count - 2) ||
+                (integerStack.Top < 0)) return;
+
+            var index = (int) integerStack.Pop();
+            var item = integerStack.ReverseElementAt(index);
+
+            integerStack.Push(item);
+        }
+
+        private bool TryGetItem<E>(IStack<E> stack, IStack<long> integerStack, out E item)
+        {
+            if ((integerStack.Count == 0) || (integerStack.Top >= stack.Count) || (integerStack.Top < 0) ||
+                (stack.Count < 2))
+            {
+                item = default(E);
+                return false;
+            }
+
+            var index = (int) integerStack.Pop();
+            item = stack.ReverseElementAt(index);
+
+            return true;
+        }
     }
 
-    public void Eval(IStack<Expression> stack, IStack<long> integerStack)
+    public class IntegerYankDuplicateExpression : YankDuplicateExpression<long>
     {
-      Expression item;
-      if (this.TryGetItem(stack, integerStack, out item)) stack.Push(item);
+        public IntegerYankDuplicateExpression() : base("INTEGER.YANKDUP")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack);
+        }
     }
 
-    public void Eval(IStack<long> integerStack)
+    public class FloatYankDuplicateExpression : YankDuplicateExpression<double>
     {
-      if ((integerStack.Count < 2) || (integerStack.Top > integerStack.Count - 2) || (integerStack.Top < 0)) return;
+        public FloatYankDuplicateExpression() : base("FLOAT.YANKDUP")
+        {
+        }
 
-      var index = (int)integerStack.Pop();
-      var item = integerStack.ReverseElementAt(index);
-
-      integerStack.Push(item);
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+        }
     }
 
-    private bool TryGetItem<E>(IStack<E> stack, IStack<long> integerStack, out E item)
+    public class BooleanYankDuplicateExpression : YankDuplicateExpression<bool>
     {
-      if ((integerStack.Count == 0) || (integerStack.Top >= stack.Count) || (integerStack.Top < 0) || (stack.Count < 2))
-      {
-        item = default(E);
-        return false;
-      }
+        public BooleanYankDuplicateExpression() : base("BOOLEAN.YANKDUP")
+        {
+        }
 
-      var index = (int)integerStack.Pop();
-      item = stack.ReverseElementAt(index);
-
-      return true;
-    }
-  }
-
-  public class IntegerYankDuplicateExpression : YankDuplicateExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.YANKDUP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class NameYankDuplicateExpression : YankDuplicateExpression<string>
     {
-      this.Eval(interpreter.IntegerStack);
-    }
-  }
+        public NameYankDuplicateExpression() : base("NAME.YANKDUP")
+        {
+        }
 
-  public class FloatYankDuplicateExpression : YankDuplicateExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.YANKDUP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class ExecYankDuplicateExpression : YankDuplicateExpression<Expression>
     {
-      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
-    }
-  }
+        public ExecYankDuplicateExpression() : base("EXEC.YANKDUP")
+        {
+        }
 
-  public class BooleanYankDuplicateExpression : YankDuplicateExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.YANKDUP";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class CodeYankDuplicateExpression : YankDuplicateExpression<Expression>
     {
-      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+        public CodeYankDuplicateExpression() : base("CODE.YANKDUP")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+        }
     }
-  }
-
-  public class NameYankDuplicateExpression : YankDuplicateExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.YANKDUP";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
-    }
-  }
-
-  public class ExecYankDuplicateExpression : YankDuplicateExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.YANKDUP";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
-    }
-  }
-
-  public class CodeYankDuplicateExpression : YankDuplicateExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.YANKDUP";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
-    }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/YankExpressions.cs	(revision 14602)
@@ -1,103 +1,101 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+    using HeuristicLab.Algorithms.PushGP.Interpreter;
+    using HeuristicLab.Algorithms.PushGP.Stack;
 
-  /// <summary>
-  ///     Removes an indexed item from "deep" in the stack and pushes it on top of the stack.
-  ///     The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
-  /// </summary>
-  /// <typeparam name="T">Stacktype</typeparam>
-  public abstract class YankExpression<T> : StatelessExpression
-  {
-    public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
+    /// <summary>
+    ///     Removes an indexed item from "deep" in the stack and pushes it on top of the stack.
+    ///     The index is taken from the INTEGER stack, and the indexing is done after the index is removed.
+    /// </summary>
+    /// <typeparam name="T">Stacktype</typeparam>
+    public abstract class YankExpression<T> : StatelessExpression
     {
-      if (integerStack.Count == 0) return;
+        protected YankExpression(string stringRepresentation) : base(stringRepresentation)
+        {
+        }
 
-      var index = integerStack.Top;
+        public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
+        {
+            if (integerStack.Count == 0) return;
 
-      if ((index > stack.Count - count) || (index < 0) || (stack.Count < 2)) return;
+            var index = integerStack.Top;
 
-      integerStack.Pop();
-      stack.Yank((int)index);
-    }
-  }
+            if ((index > stack.Count - count) || (index < 0) || (stack.Count < 2)) return;
 
-  public class IntegerYankExpression : YankExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.YANK";
+            integerStack.Pop();
+            stack.Yank((int) index);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class IntegerYankExpression : YankExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
-    }
-  }
+        public IntegerYankExpression() : base("INTEGER.YANK")
+        {
+        }
 
-  public class FloatYankExpression : YankExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.YANK";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class FloatYankExpression : YankExpression<double>
     {
-      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
-    }
-  }
+        public FloatYankExpression() : base("FLOAT.YANK")
+        {
+        }
 
-  public class BooleanYankExpression : YankExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.YANK";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class BooleanYankExpression : YankExpression<bool>
     {
-      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
-    }
-  }
+        public BooleanYankExpression() : base("BOOLEAN.YANK")
+        {
+        }
 
-  public class NameYankExpression : YankExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.YANK";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class NameYankExpression : YankExpression<string>
     {
-      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
-    }
-  }
+        public NameYankExpression() : base("NAME.YANK")
+        {
+        }
 
-  public class ExecYankExpression : YankExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.YANK";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.NameStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class ExecYankExpression : YankExpression<Expression>
     {
-      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
-    }
-  }
+        public ExecYankExpression() : base("EXEC.YANK")
+        {
+        }
 
-  public class CodeYankExpression : YankExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.YANK";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class CodeYankExpression : YankExpression<Expression>
     {
-      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+        public CodeYankExpression() : base("CODE.YANK")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+        }
     }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Generators/CodeGenerator.cs	(revision 14602)
@@ -27,5 +27,5 @@
     /// <returns>Returns an ExpandExpression if maxPoints smaller or equal to Configuration.MaxProgramPoints and Noop otherwise</returns>
     public static ExecExpandExpression RandomProgram(int maxPoints, IDictionary<string, Expression> customExpressions = null) {
-      var code = RandomCode(maxPoints, customExpressions).ToArray();
+      var code = RandomCode(maxPoints, customExpressions);
 
       return new ExecExpandExpression(code);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.csproj	(revision 14602)
@@ -53,5 +53,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Data\Pool\IRecyclable.cs" />
+    <Compile Include="Attributes\PushExpressionAttriubte.cs" />
     <Compile Include="Data\Pool\ObjectPool.cs" />
     <Compile Include="Data\Random\RandomFactory.cs" />
@@ -71,4 +71,5 @@
     <Compile Include="Expressions\StatefullExpression.cs" />
     <Compile Include="Expressions\StatelessExpression.cs" />
+    <Compile Include="Expressions\WrapperExpression.cs" />
     <Compile Include="Expressions\YankDuplicateExpressions.cs" />
     <Compile Include="Expressions\YankExpressions.cs" />
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IPushGpInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IPushGpInterpreter.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IPushGpInterpreter.cs	(revision 14602)
@@ -1,4 +1,3 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
-  using System;
   using System.Collections.Generic;
   using System.Threading;
@@ -26,11 +25,11 @@
     bool IsNameQuoteFlagSet { get; set; }
 
-    void Interpret(string code);
+    void Run(string code);
 
-    Task InterpretAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken));
+    Task RunAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken));
 
-    void Interpret(Expression program);
+    void Run(Expression program);
 
-    Task InterpretAsync(Expression program, bool paused = false, CancellationToken token = default(CancellationToken));
+    Task RunAsync(Expression program, bool paused = false, CancellationToken token = default(CancellationToken));
 
     Task AbortAndResetAsync();
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PooledPushGpInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PooledPushGpInterpreter.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PooledPushGpInterpreter.cs	(revision 14602)
@@ -2,7 +2,5 @@
   using System;
 
-  using HeuristicLab.Algorithms.PushGP.Data.Pool;
-
-  public class PooledPushGpInterpreter : PushGpInterpreter, IRecyclable, IDisposable {
+  public class PooledPushGpInterpreter : PushGpInterpreter, IDisposable {
 
     private readonly PushGpInterpreterPool container;
@@ -13,10 +11,7 @@
     }
 
-    void IRecyclable.Recycle() {
+    public void Dispose() {
       this.Reset();
-      this.Configuration = this.container.Configuration;
-    }
-
-    public void Dispose() {
+      this.Configuration = this.Configuration;
       this.container.Free(this);
     }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGPInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGPInterpreter.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGPInterpreter.cs	(revision 14602)
@@ -76,28 +76,28 @@
     public bool IsNameQuoteFlagSet { get; set; }
 
-    public void Interpret(string code) {
+    public void Run(string code) {
       var program = PushGPParser.Parse(code);
-      this.Interpret(program);
-    }
-
-    public Task InterpretAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken)) {
+      this.Run(program);
+    }
+
+    public Task RunAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken)) {
       var program = PushGPParser.Parse(code);
 
-      this.currentTask = this.InterpretAsync(program, paused, token);
-
-      return this.currentTask;
-    }
-
-    public Task InterpretAsync(
+      this.currentTask = this.RunAsync(program, paused, token);
+
+      return this.currentTask;
+    }
+
+    public Task RunAsync(
       Expression program,
       bool paused = false,
       CancellationToken token = default(CancellationToken)) {
       this.IsPaused = paused;
-      this.currentTask = Task.Run(() => this.Interpret(program), token);
-
-      return this.currentTask;
-    }
-
-    public void Interpret(Expression program) {
+      this.currentTask = Task.Run(() => this.Run(program), token);
+
+      return this.currentTask;
+    }
+
+    public void Run(Expression program) {
       /* Push top expression so the loop is able to enter
        * If the top expression is a single statement then the loop has nothing to do
@@ -160,4 +160,10 @@
       this.PrintStack("FLOAT", this.FloatStack);
       this.PrintStack("INTEGER", this.IntegerStack);
+
+      if (this.CustomExpressions.Count == 0) return;
+      Console.WriteLine("--------- Custom Expressions ---------");
+      foreach (var ce in this.CustomExpressions) {
+        Console.WriteLine("{0}: {1}", ce.Key, ce.Value);
+      }
     }
 
@@ -208,5 +214,7 @@
 
     private void DoStep() {
-      this.ExecStack.Pop().Eval(this);
+      var e = this.ExecStack.Pop();
+
+      e.Eval(this);
     }
 
@@ -218,5 +226,6 @@
 
     private void PrintStack<T>(string name, IStack<T> stack) {
-      Console.WriteLine("--- {0} ---\n{1}\n---------------------------------------------------", name, stack);
+      if (stack.IsEmpty) return;
+      Console.WriteLine("--------- {0} ---------\n{1}\n", name, stack);
     }
   }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Stack/PushGPStack.cs	(revision 14602)
@@ -3,4 +3,5 @@
   using System.Collections;
   using System.Collections.Generic;
+  using System.Linq;
 
   /// <summary>
@@ -240,5 +241,6 @@
 
     public override string ToString() {
-      return string.Join(Delimiter, this.data);
+      var data = this.data as IEnumerable<T>;
+      return string.Join(Delimiter, data.Reverse());
     }
   }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 14602)
@@ -1,32 +1,134 @@
-﻿namespace HeuristicLab.BenchmarkSuite
-{
+﻿namespace HeuristicLab.BenchmarkSuite {
+  using System;
   using System.Collections.Generic;
+  using System.IO;
+  using System.IO.Compression;
+  using System.Linq;
+  using System.Reflection;
+  using System.Text.RegularExpressions;
 
-  using HeuristicLab.Core;
-  using HeuristicLab.Random;
+  using HeuristicLab.BenchmarkSuite.ProblemData;
 
-  public abstract class BenchmarkSuiteDataDescritpor<T> : ArtificialDataDescriptor
-  {
-    protected static IRandom rand = new FastRandom();
+  using Microsoft.VisualBasic.FileIO;
 
-    protected abstract IEnumerable<T> GenerateTraining();
+  public abstract class BenchmarkSuiteDataDescriptor<TIn, TOut> : IBenchmarkSuiteDataDescriptor {
+    //protected static IRandom rand = new FastRandom();
 
-    protected abstract IEnumerable<T> GenerateTest();
+    private const string InstanceArchiveName = "HeuristicLab.BenchmarkSuite.Data.BenchmarkExamples.zip";
+    private const string TestProblemPostfix = "Test.csv";
+    private const string TrainingProblemPostfix = "Training.csv";
+    private const string ResourcePath = @".*\.Data\.";
+    private const string ExampleSeparator = ",";
 
-    protected abstract IEnumerable<Example> GenerateExamples(IEnumerable<T> trainingAndTest);
+    protected const char ArrayValueSeparator = ' ';
+    protected static readonly char[] ArraySymbolTrim = { '[', ']' };
 
-    protected override IEnumerable<Example> GenerateExamples()
-    {
-      var training = this.GenerateTraining();
+    public abstract string Name { get; }
+    public abstract string Description { get; }
 
-      training = training.Shuffle(rand);
+    protected abstract int InputCount { get; }
+    protected abstract int OutputCount { get; }
 
-      var test = this.GenerateTest();
+    public abstract TIn ConvertInput(string[] input);
+    public abstract TOut ConvertOutput(string[] input);
 
-      var all = new List<T>();
-      all.AddRange(training);
-      all.AddRange(test);
+    public IData CreateData() {
+      var training = this.GetTraining();
+      var test = this.GetTest();
 
-      return this.GenerateExamples(all);
+      return new Data<TIn, TOut>(training, test, 0, double.MaxValue);
+    }
+
+    public IPushData CreatePushData() {
+      var training = this.GetTraining();
+      var test = this.GetTest();
+
+      return this.CreatePushData(training, test);
+    }
+
+    private Example<TIn, TOut>[] GetTest() {
+      return this.ParseData(TestProblemPostfix).ToArray();
+    }
+
+    private Example<TIn, TOut>[] GetTraining() {
+      return this.ParseData(TrainingProblemPostfix)/*.Shuffle(rand)*/.ToArray(); ;
+    }
+
+    public abstract IPushData CreatePushData(Example<TIn, TOut>[] training, Example<TIn, TOut>[] test);
+
+    protected IEnumerable<Example<TIn, TOut>> ParseData(string postfix) {
+      var type = this.GetType();
+      var problemInstanceName = type.Name + postfix;
+
+      using (var file = this.GetType().Assembly.GetManifestResourceStream(InstanceArchiveName))
+      using (var archive = new ZipArchive(file, ZipArchiveMode.Read)) {
+        var entry = archive.Entries.SingleOrDefault(x => x.Name == problemInstanceName);
+
+        using (var parser = new TextFieldParser(entry.Open())) {
+          parser.TextFieldType = FieldType.Delimited;
+          parser.SetDelimiters(ExampleSeparator);
+
+          while (!parser.EndOfData) {
+            //Processing row
+            var fields = parser.ReadFields();
+
+            if (fields.Length != InputCount + OutputCount)
+              throw new InvalidDataException("Number of values do not fit");
+
+            yield return new Example<TIn, TOut> {
+              Input = ConvertInput(fields.Take(this.InputCount).ToArray()),
+              Output = ConvertOutput(fields.Skip(this.InputCount).ToArray())
+            };
+          }
+        }
+      }
+    }
+
+    protected static string GetResourceName(string fileName) {
+      return Assembly
+          .GetExecutingAssembly()
+          .GetManifestResourceNames()
+          .SingleOrDefault(x => Regex.Match(x, ResourcePath + fileName).Success);
+    }
+
+    protected static double[] ConvertDoubles(string input) {
+      return ConvertMultiple(input, double.Parse);
+    }
+
+    protected static double ConvertDouble(string input) {
+      return double.Parse(input);
+    }
+
+    protected static long[] ConvertIntegers(string input) {
+      return ConvertMultiple(input, long.Parse);
+    }
+
+    protected static long ConvertInteger(string input) {
+
+      return string.IsNullOrEmpty(input) ? default(long) : long.Parse(input);
+    }
+
+    protected static T[] ConvertMultiple<T>(string input, Func<string, T> converter) {
+      return input
+       .Trim(ArraySymbolTrim)
+       .Split(ArrayValueSeparator)
+       .Where(s => !string.IsNullOrWhiteSpace(s))
+       .Select(converter)
+       .ToArray();
+    }
+
+    protected static IEnumerable<string> SplitByNewLine(string input) {
+      return input.Split(new[] { Environment.NewLine, "\n", "\r\n" }, StringSplitOptions.None);
+    }
+
+    private static string[] trueFormats = new[] { "true", "t", "1" };
+    private static string[] falseFormats = new[] { "false", "f", "0" };
+
+    protected static bool ConvertBool(string input) {
+      var str = input.ToLower();
+
+      if (trueFormats.Contains(str)) return true;
+      if (falseFormats.Contains(str)) return false;
+      throw new InvalidDataException(string.Format("Unable to parse {0} as boolean", str));
     }
   }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs	(revision 14602)
@@ -0,0 +1,58 @@
+﻿using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.BenchmarkSuite {
+
+  using HeuristicLab.BenchmarkSuite.ProblemData;
+  using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Problems.Instances;
+
+  public abstract class BenchmarkSuiteInstanceProvider<TData> : ProblemInstanceProvider<TData>
+    where TData : IData {
+    private const string name = "General Program Synthesis Benchmark Suite";
+    private const string referencePublication =
+      "T. Helmuth and L. Spector, \"Detailed Problem Descriptions for General Program Synthesis Benchmark Suite\", Technical Report UM-CS-2015-006, School of Computer Science, University of Massachusetts Amherst, 2015.";
+    private static readonly Uri webLink = new Uri("https://web.cs.umass.edu/publication/docs/2015/UM-CS-2015-006.pdf");
+
+    public override string Name
+    {
+      get { return name; }
+    }
+
+    public override string Description
+    {
+      get { return ""; }
+    }
+
+    public override Uri WebLink
+    {
+      get { return webLink; }
+    }
+
+    public override string ReferencePublication
+    {
+      get { return referencePublication; }
+    }
+
+    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
+      yield return new CountOdds();
+      yield return new CollatzNumbers();
+      yield return new CompareStringLengths();
+      yield return new Checksum();
+      yield return new Digits();
+      yield return new DoubleLetters();
+      yield return new EvenSquares();
+      yield return new ForLoopIndex();
+      yield return new Grades();
+      yield return new LastIndexOfZero();
+      yield return new Median();
+      yield return new MirrorImage();
+      yield return new NegativeToZero();
+      yield return new NumberIo();
+      yield return new PigLatin();
+      yield return new ReplaceSpaceWithNewline();
+    }
+
+    public abstract override TData LoadData(IDataDescriptor descriptor);
+  }
+}
